# Tests requires network access
%bcond_with test

# https://docs.fedoraproject.org/en-US/packaging-guidelines/#_do_not_use_noarch
%global debug_package %{nil}

%if 0%{!?mkrel:1}
%define mkrel(c) %{1}%{?dist}
%endif

Name:       toml11
Version:    4.4.0
Release:    %mkrel 1
Summary:    TOML for Modern C++
Summary(eo): TOML por moderna C++
Summary(tr): Modern C++ için TOML
Group:      Development/C++
License:    MIT
URL:        https://github.com/ToruNiina/toml11
Source0:    %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: (ninja or ninja-build)

%if %{with test}
BuildRequires: boost-devel
BuildRequires: git-core
%endif

%global _description %{expand:
toml11 is a C++11 (or later) header-only toml parser/encoder depending only on
C++ standard library.

  * It is compatible to the latest version of TOML v1.0.0.
  * It is one of the most TOML standard compliant libraries, tested with the
    language agnostic test suite for TOML parsers by BurntSushi.
  * It shows highly informative error messages. You can see the error messages
    about invalid files at CircleCI.
  * It has configurable container. You can use any random-access containers
    and key-value maps as backend containers.
  * It optionally preserves comments without any overhead.
  * It has configurable serializer that supports comments, inline tables,
    literal strings and multiline strings.
  * It supports user-defined type conversion from/into toml values.
  * It correctly handles UTF-8 sequences, with or without BOM, both on posix
    and Windows.}

%description %{_description}

%description -l eo
toml11 estas trajtoplena TOML-biblioteko de C++11/14/17/20.

%description -l ja
toml11は、C++11,14,17,20のための豊富な機能を持つTOML言語ライブラリです。

  * TOML言語の最新規格に準拠しています。
  * TOML言語標準のテストケースすべてにパスしています。
  * TOML言語の次期バージョン (v1.1.0) にマージされた新機能のそれぞれを試すことができます。
  * エラーが起きた位置を含めたわかりやすいエラーメッセージを出力します。
  * コメントもパースし、対応する値に保存します。
  * 16進整数やクオートの種類などのフォーマット情報を保持し、シリアライズ時に考慮します。
  * 例外を投げないバージョンをサポートします。
  * TOML値からの複雑な型変換をサポートします。
  * 整数、浮動小数点数、コンテナ等の型を変更可能です。
  * TOML言語にない一部の拡張機能を試すことができます。

%package    devel
Summary:    Development files for %{name}
Provides:   %{name}-%{static} = %{version}-%{release}

%description devel
%{_description}

Development files for %{name}.

%description devel -l eo
toml11 estas trajtoplena TOML-biblioteko de C++11/14/17/20. Ĝi kongruas kun la
plej freŝa specifo de TOML (kaj enhavas iujn trajtojn el la venonta specifo)
kaj ĝuste plenumas ties testaron. Ĝi ankaŭ havas unikajn trajtojn kaj utilaĵojn
por programistoj.

Disvolvaj dosieroj por %{name}.

%prep
%autosetup -p1


%build
%cmake \
    -G Ninja \
    %if %{with test}
    -DTOML11_BUILD_TEST=ON \
    %endif
    -DCMAKE_CXX_STANDARD=11 \
    -DTOML11_PRECOMPILE=ON \
    %{nil}
%cmake_build


%install
%cmake_install


%files devel
%license LICENSE
%doc README.md
%{_includedir}/*.hpp
%{_includedir}/toml11/
%{_libdir}/*.so
%{_libdir}/cmake/%{name}/
